#include <bits/stdc++.h>

using namespace std;

const long long MOD = 998244353;

long long bp(int a, int b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2) {
        return bp(a, b - 1) * a % MOD;
    }
    long long tmp = bp(a, b / 2);
    return tmp * tmp % MOD;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> b(q);
    for (int i = 0; i < q; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < q; i++) {
        if (b[i] == 1) {
            reverse(a.begin(), a.end());
        } else if (b[i] == 2) {
            for (int i = 0; i < n; i++) {
                a[i] = n - a[i] + 1;
            }
        } else {
            vector<int> c(n);
            for (int i = 0; i < n; i++) {
                c[a[i] - 1] = i + 1;
            }
            a = c;
        }
        long long ans = 0, ans2 = 0;
        for (int i = 0; i < n; i++) {
            ans = (ans + bp(a[i], i + 1)) % MOD;
        } 
        cout << ans << ' ';
    }
}
